/* AMXMODX script.
*
* (c) Copyright 2008, developed by Lev
* This file is provided as is (no warranties).
*
*/

#include <amxmodx>
#include <amxmisc>
#include <sockets>
#include <icqbot>

#define PLUGIN "Admin ICQ"
#define AUTHOR "Lev"
#define VERSION "1.7"
#define VERSION_CVAR "adminicq_version"

const BASE_TASK_ID = 4346		// random number
const SOCKET_TASK_ID = 57343;
const Float:RECEVIE_DELAY = 0.1;// Time in seconds
const WAIT_FOR_RESPONSE = 4;	// Time in seconds * RECEVIE_DELAY

new pcvar_adminicq_admins;
new pcvar_adminicq_trigger;
new pcvar_adminicq_showinfo;
new pcvar_adminicq_flood_time;
new pcvar_adminicq_allowexec;

new socket = 0;
new err;
new pcvar_rcon_password;
new pcvar_ip;
new pcvar_port;
new command[1024];
new uinForResponse[32];

new Float:flooding[33] = {0.0, ...};
new flood[33] = {0, ...};

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_cvar(VERSION_CVAR, VERSION, FCVAR_SERVER);

	register_clcmd("say", "SayEvent");
	register_clcmd("say_team", "SayEvent");
	pcvar_adminicq_admins = register_cvar("adminicq_admins","");
	pcvar_adminicq_trigger = register_cvar("adminicq_trigger","!admin");
	pcvar_adminicq_showinfo = register_cvar("adminicq_showinfo","1");
	pcvar_adminicq_flood_time = register_cvar("adminicq_flood_time", "600");
	pcvar_adminicq_allowexec = register_cvar("adminicq_allowexec", "0");

	register_icq_message_handler("IncomingMessageHandler");

	pcvar_rcon_password = get_cvar_pointer("rcon_password");
	pcvar_ip = get_cvar_pointer("ip");
	pcvar_port = get_cvar_pointer("port");

	set_task(180.0, "ShowInfo", BASE_TASK_ID, _, _, "b");
}

public SayEvent(id)
{
	new text[256];
	read_args(text, sizeof(text) - 1);
	remove_quotes(text);
	new adminicq_trigger[32];
	get_pcvar_string(pcvar_adminicq_trigger, adminicq_trigger, sizeof(adminicq_trigger) - 1);
	if (adminicq_trigger[0] == 0) return PLUGIN_CONTINUE;
	if (containi(text, adminicq_trigger) != -1)
	{
		if (isFlooding(id)) return PLUGIN_HANDLED;

		prepareText(id, text, sizeof(text) - 1);
		sendToAdmins(text);

		client_print(id, print_chat, "Your message will be sent to admin.");
	}

	return PLUGIN_CONTINUE;
}

isFlooding(id)
{
	new Float:maxChat = get_pcvar_float(pcvar_adminicq_flood_time);
	if (maxChat)
	{
		new Float:nexTime = get_gametime();
		if (flooding[id] > nexTime)
		{
			if (flood[id] >= 3)
			{
				client_print(id, print_notify, "** Stop flooding an admin! **");
				flooding[id] = nexTime + maxChat + 3.0;
				return 1;
			}
			flood[id]++;
		}
		else if (flood[id])
		{
			flood[id]--;
		}
		flooding[id] = nexTime + maxChat;
	}
	return 0;
}

prepareText(id, text[], len)
{
	new szName[32];
	new szAuthID[32];
	new szIP[32];
	get_user_name(id, szName, sizeof(szName) - 1);
	get_user_authid(id, szAuthID, sizeof(szAuthID) - 1);
	get_user_ip(id, szIP, sizeof(szIP) - 1);
	new msg[256];
	format(msg, sizeof(msg) - 1, "Name: %s; ID: %s, IP: %s^r^n%s", szName, szAuthID, szIP, text);
	copy(text, len, msg);
	return msg;
}

sendToAdmins(text[])
{
	new admins[256];
	get_pcvar_string(pcvar_adminicq_admins, admins, sizeof(admins) - 1);
	sendTo(admins, sizeof(admins), text);
}

sendTo(uins[], len, text[])
{
	new uin[33];
	strtok(uins, uin, sizeof(uin) - 1, uins, len, ';', 1);
	while(!equal(uin, ""))
	{
		send_icq_message(uin, text);
		strtok(uins, uin, sizeof(uin) - 1, uins, len, ';', 1);
	}
}

public IncomingMessageHandler(from[], message[])
{
	// This will print only 255 chars even if there is more.
	//server_print("Received message ^"%s^" from %s", message, from);
	if (isAdmin(from))
	{
		if (get_pcvar_float(pcvar_adminicq_allowexec) != 0)
		{
			if (uinForResponse[0] != 0)
			{
				new uin[32];
				copy(uin, sizeof(uin) - 1, from);
				sendTo(uin, sizeof(uin) - 1, "Already processing a command. Please try again later.");
			}
			else
			{
				copy(uinForResponse, sizeof(uinForResponse) - 1, from);
				executeCommand(message);
			}
		}
		else
		{
			new text[64];
			copy(text, sizeof(text) - 1, message);
			server_cmd("say ^"%s^"", text);
		}
	}
	else
	{
		// Here can be some user functions, but may be they will be in separate file.
	}
}

isAdmin(uin[])
{
	trim(uin);
	new admin[32];
	new admins[256];
	get_pcvar_string(pcvar_adminicq_admins, admins, sizeof(admins) - 1);
	strtok(admins, admin, sizeof(admin) - 1, admins, sizeof(admins) - 1, ';', 1);
	while(!equal(admin, ""))
	{
		trim(admin);
		if (equali(admin, uin))
			return 1;
		strtok(admins, admin, sizeof(admin) - 1, admins, sizeof(admins) - 1, ';', 1);
	}
	return 0;
}

public ShowInfo()
{
	new adminicq_trigger[32];
	get_pcvar_string(pcvar_adminicq_trigger, adminicq_trigger, sizeof(adminicq_trigger) - 1);
	if (get_pcvar_float(pcvar_adminicq_showinfo) != 0 &&
		adminicq_trigger[0] != 0)
	{
		client_print(0, print_chat, "To contact a server admin on ICQ, type(say) ^"%s your text to admin^".", adminicq_trigger);
	}	
}

executeCommand(const cmd[])
{
	if (cmd[0] == 0) return 0;
	if (socket > 0) return -1;

	// Open socket.
	new ip[32];
	new port_str[10];
	get_pcvar_string(pcvar_ip, ip, sizeof(ip) - 1);
	get_pcvar_string(pcvar_port, port_str, sizeof(port_str) - 1);
	new port = str_to_num(port_str);
	socket = socket_open(ip, port, SOCKET_UDP, err);

	// Execute command directly in console if socket failed.
	if (socket <= 0)
	{
		server_cmd(cmd);
		return 2;
	}

	// Copy command.
	copy (command, sizeof(command) - 1, cmd);

	// Start rcon challenging.
	set_task(RECEVIE_DELAY, "socketReceive", SOCKET_TASK_ID, _, _, "b")

	return 1;
}

public socketReceive()
{
	static challenge[11];
	static buffer[2048] = "FFFF";
	static response[4096];
	static response_size = 0;
	static rcon_state = 0;
	static wait_count = 0;
	static reset_rcon_password = 0;

	switch(rcon_state)
	{
		case 0:	// Start challenge.
		{
			// Send query for challenge string.
			buffer[0] = buffer[1] = buffer[2] = buffer[3] = 255;
			copy(buffer[4], sizeof(buffer) - 5, "challenge rcon^n");
			err = socket_send(socket, buffer, sizeof(buffer) - 1);

			response_size = 0;
			wait_count = 0;
			rcon_state = 1;
		}
		case 1:	// Receive challenge, execute command.
		{
			// Check if response is received.
			err = socket_change(socket, 1000);
			if (err != 0)
			{
				// Read received data.
				err = socket_recv(socket, buffer, sizeof(buffer) - 1);
				// Stop if challenge is not received.
				if (!equal(buffer[4], "challenge rcon", 14))
				{
					rcon_state = 5;	// Error.
					return PLUGIN_CONTINUE;
				}
				
				// Retrive challenge string.
				new challenge_len = strlen(buffer[19]) - 1;	// Remove closing ^n
				if (challenge_len > sizeof(challenge) - 1) challenge_len = sizeof(challenge) - 1;
				copy(challenge, challenge_len, buffer[19]);

				// Get rcon password.
				new rcon_password[64];
				get_pcvar_string(pcvar_rcon_password, rcon_password, sizeof(rcon_password) - 1);
				// Generate and set rcon password if it is empty.
				if (rcon_password[0] == 0)
				{
					reset_rcon_password = 1;
					float_to_str(random_float(0.0, 10.0), rcon_password, sizeof(rcon_password) - 1);
					set_pcvar_string(pcvar_rcon_password, rcon_password);
				}

				// Execute command on rcon.
				format(buffer[4], sizeof(buffer) - 1, "rcon %s ^"%s^" %s", challenge, rcon_password, command);
				err = socket_send(socket, buffer, sizeof(buffer) - 1);

				response_size = 0;
				wait_count = 0;
				rcon_state = 3;
			}
			else
			{
				// Count retries to receive response.
				wait_count++;
				if (wait_count > WAIT_FOR_RESPONSE)
				{
					rcon_state = 5;	// Error.
					wait_count = 0;
				}
			}
		}
		case 3:	// Collect response.
		{
			// Check if response is received.
			err = socket_change(socket, 1000);
			if (err != 0)
			{
				// Read received data and store it in response buffer.
				err = socket_recv(socket, buffer, sizeof(buffer) - 1);
				copy(response[response_size], sizeof(response) - response_size - 1, buffer[5]); // +1 to skip 'l'
				response_size += err - 7;	// Skip trailing two 0x00 and leading 0xFFFFFFFF and lead 'l'
			}
			else
			{
				// Count retries to receive response.
				wait_count++;
				if (wait_count > WAIT_FOR_RESPONSE)
				{
					rcon_state = 4;	// End.
					wait_count = 0;
				}

			}
		}
		case 4:	// Close socket, process response.
		{
			// Stop pocessing socket and close it.
			remove_task(SOCKET_TASK_ID);
			err = socket_close(socket);
			socket = 0;

			// Reset rcon password if it was empty.
			if (reset_rcon_password)
			{
				set_pcvar_string(pcvar_rcon_password, "");
				reset_rcon_password = 0;
			}

			// Return to state 0.
			rcon_state = 0;

			// Do something with response.
			if (response_size > 0)
			{
				if (response[response_size - 1] == 10) // 0x0A
				{
					response[response_size - 1] = 0;
					response_size--;
				}
				sendTo(uinForResponse, sizeof(uinForResponse), response);
			}

			uinForResponse[0] = 0;
		}
		case 5:	// Error happend.
		{
			// Stop pocessing socket and close it.
			remove_task(SOCKET_TASK_ID);
			err = socket_close(socket);
			socket = 0;

			// Reset rcon password if it was empty.
			if (reset_rcon_password)
			{
				set_pcvar_string(pcvar_rcon_password, "");
				reset_rcon_password = 0;
			}

			// Return to state 0.
			rcon_state = 0;

			// Execute command directly in console.
			server_cmd(command);

			uinForResponse[0] = 0;
		}
	}

	return PLUGIN_CONTINUE;
}
